class ComplexSubject < ActiveTriples::Resource
  include CommonMethods

  configure type: ::RDF::Vocab::Rdms.Subject
  property :subject_identifier, predicate: ::RDF::Vocab::Rdms.subjectIdentifier
  property :subject_species, predicate: ::RDF::Vocab::Rdms.subjectSpecies
  property :subject_type, predicate: ::RDF::Vocab::Rdms.subjectType
  property :subject_sex, predicate: ::RDF::Vocab::Rdms.subjectSex
  property :subject_age, predicate: ::RDF::Vocab::Rdms.subjectAge

  ## Necessary to get AT to create hash URIs.
  def initialize(uri, parent)
    if uri.try(:node?)
      uri = RDF::URI("#subject#{uri.to_s.gsub('_:', '')}")
    elsif uri.start_with?("#")
      uri = RDF::URI(uri)
    end
    super
  end

end
