module DataciteMetadata
  property :doi, predicate: ::RDF::Vocab::DataCite.doi, multiple: false do |index|
    index.as :symbol
  end

  property :complex_person, predicate: ::RDF::Vocab::SIOC.has_creator, class_name:"ComplexPerson"

  # property :date_published, predicate: ::RDF::Vocab::Rdms.datePublished, multiple: false do |index|
  #   index.type :date
  #   index.as :stored_sortable
  # end

  property :complex_date, predicate: ::RDF::Vocab::DC.date, class_name:"ComplexDate"

  property :complex_identifier, predicate: ::RDF::Vocab::Rdms.identifier, class_name:"ComplexIdentifier"

  # Geolocation - would this be used? Ignoring for now.

  property :complex_funding_reference, predicate: ::RDF::Vocab::DataCite.fundref, class_name:"ComplexFundingReference"

  property :complex_relation, predicate: ::RDF::Vocab::DC.relation, class_name:"ComplexRelation"

  include ComplexValidation
  accepts_nested_attributes_for :complex_person, reject_if: :person_blank, allow_destroy: true
  accepts_nested_attributes_for :complex_date, reject_if: :date_blank, allow_destroy: true
  accepts_nested_attributes_for :complex_identifier, reject_if: :identifier_blank, allow_destroy: true
  accepts_nested_attributes_for :complex_funding_reference, reject_if: :fundref_blank, allow_destroy: true
  accepts_nested_attributes_for :complex_relation, reject_if: :relation_blank, allow_destroy: true
end