# Generated via
#  `rails generate hyrax:work CrcDataset`
require 'rails_helper'

RSpec.describe CrcDataset do
  it 'has human readable type for the CRC dataset' do
    @obj = build(:crc_dataset)
    expect(@obj.human_readable_type).to eq('Crc Dataset')
  end

  describe 'date_modified' do
    it 'has date_modified as singular' do
      @obj = build(:crc_dataset, date_modified: '2018/04/23')
      expect(@obj.date_modified).to eq '2018/04/23'
    end
  end

  describe 'date_uploaded' do
    it 'has date_uploaded as singular' do
      @obj = build(:crc_dataset, date_uploaded: '2018 01 02')
      expect(@obj.date_uploaded).to eq '2018 01 02'
    end
  end

  describe 'depositor' do
    it 'has depositor' do
      @obj = build(:crc_dataset, depositor: 'Name of depositor')
      expect(@obj.depositor).to eq 'Name of depositor'
    end
  end

  describe 'title' do
    it 'requires title' do
      @obj = build(:crc_dataset, title: nil)
      expect{@obj.save!}.to raise_error(ActiveFedora::RecordInvalid,
        'Validation failed: Title Your CRC dataset must have a title.')
    end

    it 'has a multi valued title field' do
      @obj = build(:crc_dataset, title: ['test CRC dataset'])
      expect(@obj.title).to eq ['test CRC dataset']
    end
  end

  describe 'alternative_title' do
    it 'has alternative_title' do
      @obj = build(:crc_dataset, alternative_title: ['Alternative Title'])
      expect(@obj.alternative_title).to eq ['Alternative Title']
    end
  end

  describe 'label' do
    it 'has label as singular' do
      @obj = build(:crc_dataset, label: 'Label 1')
      expect(@obj.label).to eq 'Label 1'
    end
  end

  describe 'relative_path' do
    it 'has relative_path as singular' do
      @obj = build(:crc_dataset, relative_path: 'relative/path/to/file')
      expect(@obj.relative_path).to eq 'relative/path/to/file'
    end
  end

  describe 'import_url' do
    it 'has import_url as singular' do
      @obj = build(:crc_dataset, import_url: 'http://example.com/import/url')
      expect(@obj.import_url).to eq 'http://example.com/import/url'
    end
  end

  describe 'resource_type' do
    it 'has resource_type' do
      @obj = build(:crc_dataset, resource_type: ['CRC Dataset'])
      expect(@obj.resource_type).to eq ['CRC Dataset']
    end
  end

  describe 'creator' do
    it 'has creator' do
      @obj = build(:crc_dataset, creator: ['Creator 1'])
      expect(@obj.creator).to eq ['Creator 1']
    end
  end

  describe 'contributor' do
    it 'has contributor' do
      @obj = build(:crc_dataset, contributor: ['contributor 1'])
      expect(@obj.contributor).to eq ['contributor 1']
    end
  end

  describe 'description' do
    it 'has description' do
      @obj = build(:crc_dataset, description: ['description 1'])
      expect(@obj.description).to eq ['description 1']
    end
  end

  describe 'abstract' do
    it 'has abstract' do
      @obj = build(:crc_dataset, abstract: ['abstract 1'])
      expect(@obj.abstract).to eq ['abstract 1']
    end
  end

  describe 'keyword' do
    it 'has keyword' do
      @obj = build(:crc_dataset, keyword: ['keyword 2', '3 keyword', 'keyword 1'])
      expect(@obj.keyword).to eq ['keyword 2', '3 keyword', 'keyword 1']
    end
  end

  describe 'license' do
    it 'has license' do
      @obj = build(:crc_dataset, license: ['CC-0'])
      expect(@obj.license).to eq ['CC-0']
    end
  end

  describe 'rights_notes' do
    it 'has rights_notes' do
      @obj = build(:crc_dataset, rights_notes: ['rights_notes 1'])
      expect(@obj.rights_notes).to eq ['rights_notes 1']
    end
  end

  describe 'rights_statement' do
    it 'has rights_statement' do
      @obj = build(:crc_dataset, rights_statement: ['rights_statement 1'])
      expect(@obj.rights_statement).to eq ['rights_statement 1']
    end
  end

  describe 'access_right' do
    it 'has access_right' do
      @obj = build(:crc_dataset, access_right: ['access_right 1'])
      expect(@obj.access_right).to eq ['access_right 1']
    end
  end

  describe 'publisher' do
    it 'has publisher' do
      @obj = build(:crc_dataset, publisher: ['publisher 1'])
      expect(@obj.publisher).to eq ['publisher 1']
    end
  end

  describe 'date_created' do
    it 'has date_created' do
      @obj = build(:crc_dataset, date_created: ['date_created 1'])
      expect(@obj.date_created).to eq ['date_created 1']
    end
  end

  describe 'subject' do
    it 'has subject' do
      @obj = build(:crc_dataset, subject: ['subject 1'])
      expect(@obj.subject).to eq ['subject 1']
    end
  end

  describe 'language' do
    it 'has language' do
      @obj = build(:crc_dataset, language: ['language 1'])
      expect(@obj.language).to eq ['language 1']
    end
  end

  describe 'identifier' do
    it 'has identifier' do
      @obj = build(:crc_dataset, identifier: ['identifier 1'])
      expect(@obj.identifier).to eq ['identifier 1']
    end
  end

  describe 'based_near' do
    it 'has based_near' do
      @obj = build(:crc_dataset, based_near: ['me'])
      expect(@obj.based_near).to eq ['me']
    end
  end

  describe 'related_url' do
    it 'has related_url' do
      @obj = build(:crc_dataset, related_url: ['http://example.com/related/url'])
      expect(@obj.related_url).to eq ['http://example.com/related/url']
    end
  end

  describe 'bibliographic_citation' do
    it 'has bibliographic_citation' do
      @obj = build(:crc_dataset, bibliographic_citation: ['bibliographic_citation 1'])
      expect(@obj.bibliographic_citation).to eq ['bibliographic_citation 1']
    end
  end

  describe 'source' do
    it 'has source' do
      @obj = build(:crc_dataset, source: ['Source 1'])
      expect(@obj.source).to eq ['Source 1']
    end
  end

  describe 'doi' do
    it 'has doi as singular' do
      @obj = build(:crc_dataset, doi: '123167641234')
      expect(@obj.doi).to eq '123167641234'
    end
  end

  describe 'complex_person' do
    it 'creates a person active triple resource with name' do
      @obj = build(:crc_dataset,
                   complex_person_attributes: [{
                                                 name: 'Anamika'
                                               }]
      )
      expect(@obj.complex_person.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_person.first.name).to eq ['Anamika']
      expect(@obj.complex_person.first.first_name).to be_empty
      expect(@obj.complex_person.first.last_name).to be_empty
      expect(@obj.complex_person.first.email).to be_empty
      expect(@obj.complex_person.first.affiliation).to be_empty
      expect(@obj.complex_person.first.role).to be_empty
      expect(@obj.complex_person.first.orcid).to be_empty
      expect(@obj.complex_person.first.display_order).to be_empty
    end

    it 'creates a person active triple resource with name, affiliation, orcid, role and display order' do
      @obj = build(:crc_dataset,
                   complex_person_attributes: [{
                                                 name: 'Anamika',
                                                 affiliation: 'Some org',
                                                 role: 'Creator',
                                                 orcid: '1231234',
                                                 display_order: 1
                                               }]
      )
      expect(@obj.complex_person.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_person.first.name).to eq ['Anamika']
      expect(@obj.complex_person.first.first_name).to be_empty
      expect(@obj.complex_person.first.last_name).to be_empty
      expect(@obj.complex_person.first.email).to be_empty
      expect(@obj.complex_person.first.role).to eq ['Creator']
      expect(@obj.complex_person.first.orcid).to eq ['1231234']
      expect(@obj.complex_person.first.display_order).to eq([1])
      expect(@obj.complex_person.first.affiliation).to eq(['Some org'])
    end

    it 'rejects person active triple with no name and only orcid' do
      @obj = build(:crc_dataset, complex_person_attributes: [{
                                                           orcid: 'http://example.com/person/123456'
                                                         }]
      )
      expect(@obj.complex_person).to be_empty
    end
  end

  describe 'complex_date' do
    it 'creates a date active triple resource with all the attributes' do
      @obj = build(:crc_dataset,
                   complex_date_attributes: [{
                                               date: '1978-10-28',
                                               description: 'Some kind of a date',
                                             }]
      )
      expect(@obj.complex_date.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_date.first.date).to eq ['1978-10-28']
      expect(@obj.complex_date.first.description).to eq ['Some kind of a date']
    end

    it 'creates a date active triple resource with just the date' do
      @obj = build(:crc_dataset,
                   complex_date_attributes: [{
                                               date: '1984-09-01'
                                             }]
      )
      expect(@obj.complex_date.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_date.first.date).to eq ['1984-09-01']
      expect(@obj.complex_date.first.description).to be_empty
    end

    it 'rejects a date active triple with no date' do
      @obj = build(:crc_dataset,
                   complex_date_attributes: [{
                                               description: 'Local date'
                                             }]
      )
      expect(@obj.complex_date).to be_empty
    end
  end

  describe 'complex_identifier' do
    it 'creates an identifier active triple resource with all the attributes' do
      @obj = build(:crc_dataset,
                   complex_identifier_attributes: [{
                                                     identifier: '0000-0000-0000-0000',
                                                     scheme: 'uri_of_ORCID_scheme',
                                                     label: 'ORCID'
                                                   }]
      )
      expect(@obj.complex_identifier.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_identifier.first.identifier).to eq ['0000-0000-0000-0000']
      expect(@obj.complex_identifier.first.scheme).to eq ['uri_of_ORCID_scheme']
      expect(@obj.complex_identifier.first.label).to eq ['ORCID']
    end

    it 'creates an identifier active triple resource with just the identifier' do
      @obj = build(:crc_dataset,
                   complex_identifier_attributes: [{
                                                     identifier: '1234'
                                                   }]
      )
      expect(@obj.complex_identifier.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_identifier.first.identifier).to eq ['1234']
      expect(@obj.complex_identifier.first.label).to be_empty
      expect(@obj.complex_identifier.first.scheme).to be_empty
    end

    it 'rejects an identifier active triple with no identifier' do
      @obj = build(:crc_dataset,
                   complex_identifier_attributes: [{
                                                     label: 'Local'
                                                   }]
      )
      expect(@obj.complex_identifier).to be_empty
    end
  end

  describe 'complex_funding_reference' do
    it 'creates a complex funding reference active triple resource with funding reference' do
      @obj = build(:crc_dataset,
                   complex_funding_reference_attributes: [{
                                                            funder_identifier: 'f1234',
                                                            funder_name: 'Bank',
                                                            award_title: 'No free lunch'
                                                          }]
      )
      expect(@obj.complex_funding_reference.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_funding_reference.first.id).to include('#fundref')
      expect(@obj.complex_funding_reference.first.funder_identifier).to eq ['f1234']
      expect(@obj.complex_funding_reference.first.funder_name).to eq ['Bank']
      expect(@obj.complex_funding_reference.first.award_number).to be_empty
      expect(@obj.complex_funding_reference.first.award_uri).to be_empty
      expect(@obj.complex_funding_reference.first.award_title).to eq ['No free lunch']
    end

    it 'creates a complex funding reference active triple resource with all the attributes' do
      @obj = build(:crc_dataset,
                   complex_funding_reference_attributes: [{
                                                            funder_identifier: 'f1234',
                                                            funder_name: 'Bank',
                                                            award_number: 'a1234',
                                                            award_uri: 'http://award.com/a1234',
                                                            award_title: 'No free lunch'
                                                          }]
      )
      expect(@obj.complex_funding_reference.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_funding_reference.first.id).to include('#fundref')
      expect(@obj.complex_funding_reference.first.funder_identifier).to eq ['f1234']
      expect(@obj.complex_funding_reference.first.funder_name).to eq ['Bank']
      expect(@obj.complex_funding_reference.first.award_number).to eq ['a1234']
      expect(@obj.complex_funding_reference.first.award_uri).to eq ['http://award.com/a1234']
      expect(@obj.complex_funding_reference.first.award_title).to eq ['No free lunch']
    end

    it 'rejects a complex funding reference active triple with no attributes' do
      @obj = build(:crc_dataset,
                   complex_funding_reference_attributes: [{
                                                            funder_identifier: '',
                                                            funder_name: ''
                                                          }]
      )
      expect(@obj.complex_funding_reference).to be_empty
    end
  end

  describe 'complex_relation' do
    it 'creates a relation active triple resource with all the attributes' do
      @obj = build(:crc_dataset,
                   complex_relation_attributes: [{
                                                   title: 'A related item',
                                                   url: 'http://example.com/relation',
                                                   complex_identifier_attributes: [{
                                                                                     identifier: ['123456'],
                                                                                     label: ['local']
                                                                                   }],
                                                   relationship: 'IsPartOf'
                                                 }]
      )
      expect(@obj.complex_relation.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_relation.first.title).to eq ['A related item']
      expect(@obj.complex_relation.first.url).to eq ['http://example.com/relation']
      expect(@obj.complex_relation.first.complex_identifier.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_relation.first.complex_identifier.first.identifier).to eq ['123456']
      expect(@obj.complex_relation.first.complex_identifier.first.label).to eq ['local']
      expect(@obj.complex_relation.first.relationship).to eq ['IsPartOf']
    end

    it 'creates a relation active triple resource with title, url, identifier and relationship role' do
      @obj = build(:crc_dataset,
                   complex_relation_attributes: [{
                                                   title: 'A relation label',
                                                   url: 'http://example.com/relation',
                                                   complex_identifier_attributes: [{
                                                                                     identifier: ['123456']
                                                                                   }],
                                                   relationship: 'isNewVersionOf'
                                                 }]
      )
      expect(@obj.complex_relation.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_relation.first.title).to eq ['A relation label']
      expect(@obj.complex_relation.first.url).to eq ['http://example.com/relation']
      expect(@obj.complex_relation.first.complex_identifier.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_relation.first.complex_identifier.first.identifier).to eq ['123456']
      expect(@obj.complex_relation.first.complex_identifier.first.label).to be_empty
      expect(@obj.complex_relation.first.relationship).to eq ['isNewVersionOf']
    end

    it 'rejects relation active triple with url' do
      @obj = build(:crc_dataset, complex_relation_attributes: [{
                                                                 url: 'http://example.com/relation'
                                                               }]
      )
      expect(@obj.complex_relation).to be_empty
    end

    it 'rejects relation active triple with identifier' do
      @obj = build(:crc_dataset,
                   complex_relation_attributes: [{
                                                   complex_identifier_attributes: [{
                                                                                     identifier: ['123456'],
                                                                                     label: 'Local'
                                                                                   }],
                                                 }]
      )
      expect(@obj.complex_relation).to be_empty
    end

    it 'rejects relation active triple with reltionship name' do
      @obj = build(:crc_dataset, complex_relation_attributes: [{
                                                                 relationship: 'isPartOf'
                                                               }]
      )
      expect(@obj.complex_relation).to be_empty
    end
  end

  # ------ properties from CRC metadata ------
  describe `crc_resource_type` do
    it 'has crc_resource_type' do
      @obj = build(:crc_dataset, crc_resource_type: 'Analysed')
      expect(@obj.crc_resource_type).to eq 'Analysed'
    end
  end

  describe `modality` do
    it 'has modality' do
      @obj = build(:crc_dataset, modality: 'modality 1')
      expect(@obj.modality).to eq 'modality 1'
    end
  end

  describe 'complex_subject' do
    it 'creates a subject active triple resource with species' do
      @obj = build(:crc_dataset,
                   complex_subject_attributes: [{
                                                  subject_species: 'human',
                                                 }]
      )

      expect(@obj.complex_subject.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_subject.first.subject_species).to eq ['human']
      expect(@obj.complex_subject.first.subject_type).to be_empty
      expect(@obj.complex_subject.first.subject_sex).to be_empty
      expect(@obj.complex_subject.first.subject_age).to be_empty
    end

    it 'creates a subject active triple resource with species, type, sex and age' do
      @obj = build(:crc_dataset,
                   complex_subject_attributes: [{
                                                  subject_species: 'human',
                                                  subject_type: 'disease',
                                                  subject_sex: 'm',
                                                  subject_age: '22'
                                                 }]
      )
      expect(@obj.complex_subject.first).to be_kind_of ActiveTriples::Resource
      expect(@obj.complex_subject.first.subject_species).to eq ['human']
      expect(@obj.complex_subject.first.subject_type).to eq ['disease']
      expect(@obj.complex_subject.first.subject_sex).to eq ['m']
      expect(@obj.complex_subject.first.subject_age).to eq ['22']
    end

  end

  describe 'approval_number' do
    it 'has approval_number' do
      @obj = build(:crc_dataset, approval_number: 'approval_number 1')
      expect(@obj.approval_number).to eq 'approval_number 1'
    end
  end

  describe 'extra_information' do
    it 'has extra_information' do
      @obj = build(:crc_dataset, extra_information: ['extra_information'])
      expect(@obj.extra_information).to eq ['extra_information']
    end
  end

  describe `software_version` do
    it 'has software_version' do
      @obj = build(:crc_dataset, software_version: ['software_version 1'])
      expect(@obj.software_version).to eq ['software_version 1']
    end
  end

  # ------ properties from DublinCore metadata ------
  describe `coverage` do
    it 'has coverage' do
      @obj = build(:crc_dataset, coverage: ['Europe'])
      expect(@obj.coverage).to eq ['Europe']
    end
  end

end
